
#ifndef KAFKAPROVIDERCONFIGURATOR_H_
#define KAFKAPROVIDERCONFIGURATOR_H_

#include <Base_Configurator.h>
#include <Kafka_Provider.h>

namespace inaf::oasbo::Providers {

class KafkaProviderConfigurator : public BaseConfigurator{

public:
	KafkaProviderConfigurator(int argc, char **argv);
	KafkaProviderConfigurator();

	void setBrokerIP(std::string val){this->params["brokerIP"] = val;}
	void setBrokerPort(int val){this->params["brokerPort"] = std::to_string(val);}
	void setTopic(std::string val){this->params["topic"] = val;}


	std::map<std::string,std::string> getParams(){return this->params;}
	std::string getBrokerIP(){return this->params["brokerIP"];}
	int getBrokerPort(){return stoi(this->params["brokerPort"]);}
	std::string getTopic(){return this->params["topic"];}

	BaseProvider * createProvider();
	KafkaProvider * createKafkaProvider();
	void createKafkaProvider(KafkaProvider &);



	void printConfiguration(){
		std::string confStr = "Kafka Provider Configuration:\n" + this->toString();
		std::cout << confStr << std::endl;
	}

};
}
#endif
